package DnDCharacterGenerator;

import java.util.Random;

import DnDCharacterGenerator.DnDPlayersHandBook.DnDBackground;
import DnDCharacterGenerator.DnDPlayersHandBook.DnDClassWLevel;
import DnDCharacterGenerator.DnDPlayersHandBook.DnDRace;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class DnDChatacterSheetBeta {
    private Random seed;

    private String characterName;
    private DnDRace race;
    private DnDBackground background;
    private List<DnDClassWLevel> classes;

    private int level;

    private int Str;
    private int Dex;
    private int Con;
    private int Int;
    private int Wis;
    private int Cha;

    private int hp;

    private int ac;
    private int initiative;
    private int speed;

    private List skills;
    private List features;

    DnDChatacterSheetBeta() {
        this.seed = new Random();

        this.characterName = "";
        this.race = DnDRace.HUMAN;
        this.classes = new ArrayList<DnDClassWLevel>();

        this.Str = 0;
        this.Dex = 0;
        this.Con = 0;
        this.Int = 0;
        this.Wis = 0;
        this.Cha = 0;

        this.hp = 0;

        this.ac = 10;
        this.initiative = 0;
        this.speed = 30;

        this.skills = new ArrayList<>();
        this.features = new ArrayList<>();
    }

    /**
     * Generates array of 6 ability scores or "stats".
     * Each stat is generated by rolling 4 6 sided dice (also known as 4d6), summing them together and taking away the lowest resault. (4d6 pick the 3 highest)
     * 
     * @return array of 6 integers between 3 and 18
     */
    int[] generateStatArray() {
        int[] stats = new int[6];
        int[] currentRolls = new int[3];
        int roll4;
        int totalRoll;

        for (int i = 0; i < stats.length; i++) {
            totalRoll = 0;
            for (int j = 0; j < currentRolls.length; j++) { // roll 3 dice
                currentRolls[j] = seed.nextInt(5) + 1;
            }
            Arrays.sort(currentRolls); // sort the 3 rolled dice from lowest to heighest
            roll4 = seed.nextInt(5) + 1; // roll the 4th dice
            if (roll4 > currentRolls[0]) { // if the 4th roll is higher than the lowest of the three first rolls it replaces the lowest roll
                currentRolls[0] = roll4;
            }
            for (int j = 0; j < currentRolls.length; j++) { // sum the rolls toghether
                totalRoll += currentRolls[j];
            }
            stats[i] = totalRoll; // put in the array after
        }
        
        return stats;
    }

    /**
     * Generates the stat array known as "standard array", which is {15, 14, 13, 12, 10, 8}.
     * This stat array is more balanced that the array generated by generateStatArray() due to not being randomly generated.
     * 
     * @return {15, 14, 13, 12, 10, 8}
     */
    int[] generateStandardArray() {
        int[] standardArray = {15, 14, 13, 12, 10, 8};
        return standardArray;
    }

    /**
     * Sets the strength score to a set value.
     * 
     * @param x the value of the new strength score
     */
    void setStr(int x) {
        this.Str = x;
    }

    /**
     * Gets the value of the strength score.
     * 
     * @return the value of the strength score
     */
    int getStr() {
        return Str;
    }

    /**
     * Sets the dexterity score to a set value.
     * 
     * @param x the value of the new dexterity score
     */
    void setDex(int x) {
        this.Dex = x;
    }

    /**
     * Gets the value of the dexterity score.
     * 
     * @return the value of the dexterity score
     */
    int getDex() {
        return Dex;
    }

    void setCon(int x) {
        this.Con = x;
    }

    int getCon() {
        return Con;
    }

    void setInt(int x) {
        this.Int = x;
    }

    int getInt() {
        return Int;
    }

    void setWis(int x) {
        this.Wis = x;
    }

    int getWis() {
        return Wis;
    }

    void setCha(int x) {
        this.Cha = x;
    }

    int getCha() {
        return Cha;
    }

    void setHp(int x) {
        hp = x;
    }

    int getHp() {
        return hp;
    }

}